<template>
  <div class="table-holder">

    <vue-good-table
      @on-selected-rows-change="onSelectionChanged"
      :columns="columns"
      :rows="rows"
      :select-options="selectOptions"
      :sort-options="{
        enabled: false,
      }"
    />

    <div class="table-actions">
      <button
        @click="onRemove"
        :disabled="!selectedItems.length"
        class="btn btn--danger"
      >
        Delete
      </button>
      <span class="total">Total: {{ total }}</span>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import "vue-good-table/dist/vue-good-table.css";
import { VueGoodTable } from "vue-good-table";
import { mapGetters } from "vuex";

import { invoice_item } from "@/store/storeTypes";

@Component({
  components: { VueGoodTable },
  computed: {
    ...mapGetters({
      rows: "getTableData",
      total: "getTotalSum",
    }),
  },
})
export default class InvocieTable extends Vue {
  public rows!: invoice_item[];

  selectOptions = {
    enabled: true,
    selectOnCheckboxOnly: true,
    disableSelectInfo: true,
  };
  columns = [
    {
      label: "Product Name",
      field: "name",
    },
    {
      label: "Price",
      field: "price",
      type: "number",
    },
    {
      label: "Quantity",
      field: "quantity",
      type: "number",
    },
    {
      label: "Sum",
      field: "sum",
      type: "number",
    },
  ];

  selectedItems: invoice_item[] = [];

  onSelectionChanged(val: any) {
    const items = val.selectedRows.map((i: any) => i);
    this.selectedItems = items;
  }

  onRemove() {
    const newData = this.rows.filter((i: invoice_item) => {
      if (!this.selectedItems.some((i2: invoice_item) => i2.id === i.id)) {
        return i;
      }
    });
    this.$store.dispatch("setTableData", newData);
  }

}
</script>

<style lang="scss" scoped>
.table-holder {
  padding: 3rem 0;
}
.table-actions {
  padding: 1rem;
  display: flex;
  justify-content: space-between;
}
.total {
  font-size: 1.5rem;
  font-weight: bold;
}
</style>
